const Piece = @import("piece.zig");

const Self = @This();

contents: [14]?Piece.Type,

pub fn init() Self {
    var ret = Self{
        .contents = undefined,
    };
    // We must fill all of the array
    for (ret.contents[0..6]) |_, i| {
        ret.contents[i] = @intToEnum(Piece.Type, i);
    }
    // Then we would shuffle

    for (ret.contents[7..13]) |_, i| {
        ret.contents[i + 7] = @intToEnum(Piece.Type, i);
    }
    // Then we would shuffle

    return ret;
}

pub fn pop(self: *Self) Piece.Type {
    var ret = Piece.Type.i;
    if (self.contents[0]) |head| {
        ret = head;
        for (self.contents) |_, i| {
            if (self.contents[i + 1]) |next| {
                self.contents[i] = next;
                self.contents[i + 1] = null;
            } else break;
        }
        if (self.contents[7] == null) {
            for (self.contents[7..13]) |_, i| {
                self.contents[i + 7] = @intToEnum(Piece.Type, i);
            }
        }
        // Then we would shuffle

    }
    return ret;
}
